unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, activex, directshow9, Grids, ValEdit , IniFiles,
  Buttons;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    ValueListEditor1: TValueListEditor;
    Button1: TButton;
    Button2: TButton;
    SB1: TSpeedButton;
    function CreateGraph: HRESULT;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ValueListEditor1DblClick(Sender: TObject);
    procedure LoadIniFiles;
    procedure SaveIniFiles;
    procedure Panel1Resize(Sender: TObject);
    procedure SB1Click(Sender: TObject);
    procedure ValueListEditor1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
//    
//(      graphstudio  graphedit   )

CLSID_ASFReader  : TGUID = '{187463A0-5BB7-11D3-ACBE-0080C75E246E}';


var
  Form1: TForm1;
  //
  FGraphBuilder: IGraphBuilder = nil;// 
  FCaptureGraphBuilder: ICaptureGraphBuilder2 = nil;//     
  FMediaControl: IMediaControl = nil;//    
  FVideoWindow: IVideoWindow   = nil;//     
  FTee_Audio  : IBaseFilter = nil;//     
  FTee_Video  : IBaseFilter = nil;//      
  FASFReader   : IBaseFilter = nil;// source 
  FAudioRender : IBaseFilter = nil;//   
  FVideoRender : IBaseFilter = nil;//    
  FMux         : IBaseFilter = nil;//   
  FSink        : IFileSinkFilter = nil;//      

 //
  Url, Name_ch:string;
  // 
  IniFile: TIniFile;
  // 
  RecMode: Boolean = False;
  //   
  FileName:String;
  id:integer;

implementation

{$R *.dfm}

//  
function TForm1.CreateGraph;
var
  pConfigMux: IConfigAviMux;  //  
begin
//  
 if Assigned(FMediaControl) then FMediaControl:= NIL;
 if Assigned(FVideoWindow)  then FVideoWindow := NIL;
 if Assigned(FAudioRender)  then FAudioRender := nil;
 if Assigned(FVideoRender)  then  FVideoRender:= nil;
 if Assigned(FTee_Audio)  then FTee_Audio:= nil;
 if Assigned(FTee_Video)  then FTee_Video:= nil;
 if Assigned(FASFReader)  then FASFReader:= nil;
 if Assigned(FSink)  then FSink:= NIL;
 if Assigned(FMux)  then FMux:= NIL;
 if Assigned(FCaptureGraphBuilder) then FCaptureGraphBuilder   := NIL;
 if Assigned(FGraphBuilder) then FGraphBuilder:= NIL;

//    
 if Url='' then exit;
//      FGraphBuilder
CoCreateInstance(CLSID_FilterGraph, nil, CLSCTX_INPROC_SERVER, IID_IGraphBuilder, FGraphBuilder);
//      FCaptureGraphBuilder
CoCreateInstance(CLSID_CaptureGraphBuilder2, NIL, CLSCTX_INPROC_SERVER, IID_ICaptureGraphBuilder2, FCaptureGraphBuilder);

//    
FCaptureGraphBuilder.SetFiltergraph(FGraphBuilder);

//      FASFReader
CoCreateInstance(CLSID_ASFReader, nil, CLSCTX_INPROC, IID_IBaseFilter, FASFReader);
//   
FGraphBuilder.AddFilter(FASFReader, 'SourceUrl');
//   mms   Url
(FASFReader as IFileSourceFilter).Load(StringToOleStr(Url), nil);
//      audio 
CoCreateInstance(CLSID_InfTee, nil, CLSCTX_INPROC, IID_IBaseFilter, FTee_Audio);
//    
FGraphBuilder.AddFilter(FTee_Audio, 'Infinite Pin Tee Filter Audio');
//      video 
CoCreateInstance(CLSID_InfTee, nil, CLSCTX_INPROC, IID_IBaseFilter, FTee_Video);
//    
FGraphBuilder.AddFilter(FTee_Video, 'Infinite Pin Tee Filter Video');
//       FAudioRender
CoCreateInstance(CLSID_AudioRender, nil, CLSCTX_INPROC, IID_IBaseFilter, FAudioRender);
//    
FGraphBuilder.AddFilter(FAudioRender, 'DirectSound Audio Renderer');
//       FVideoRender
CoCreateInstance(CLSID_VideoMixingRenderer, nil, CLSCTX_INPROC, IID_IBaseFilter, FVideoRender);
//    
FGraphBuilder.AddFilter(FVideoRender, 'Video Renderer');

//  
with FCaptureGraphBuilder do
begin
//     FASFReader   FTee_Video
   Result:=RenderStream(nil,  @MEDIATYPE_Video, FASFReader, nil, FTee_Video);
   if FAILED(Result) then
   Begin
      ShowMessage('!      .');
      Exit;
    End;
//      FASFReader   FTee_ Audio
   Result:=RenderStream(nil, @MEDIATYPE_Audio, FASFReader, nil, FTee_Audio);
   if FAILED(Result) then
   Begin
      ShowMessage('!      ');
      Exit;
    End;
//      FTee_ Audio    FAudioRender
   Result:=RenderStream(nil, @MEDIATYPE_Audio, FTee_Audio, nil, FAudioRender);
   if FAILED(Result) then
   Begin
      ShowMessage('!      ');
      Exit;
    End;
//      FTee_Video    F VideoRender
    Result:=RenderStream(nil, @MEDIATYPE_Video, FTee_Video, nil, FVideoRender);
    if FAILED( Result ) then
   Begin
      ShowMessage('!      ');
      Exit;
   End;
end;

 //
//  
if RecMode then
begin
//           
DateTimeToString(FileName,'hh.mm.ss_dd.mm.yyyy',now);
FileName:=FileName+'.avi';
//          
FCaptureGraphBuilder.SetOutputFileName(MEDIASUBTYPE_Avi, PWideChar(StringToOleStr(AnsiString(FileName))), FMux, FSink);

//        FTee_ Video   FVideoRender
Result:=FCaptureGraphBuilder.RenderStream(nil, @MEDIATYPE_Video,  FTee_Video, Nil, FMux);
if FAILED(Result) then
 Begin
      ShowMessage('!       ');
      Exit;
 End;

//        FTee_ Audio    FAudioRender
Result:=FCaptureGraphBuilder.RenderStream(nil, @MEDIATYPE_Audio, FTee_Audio, Nil, FMux);
if FAILED( Result ) then
    Begin
      ShowMessage('!       ');
      Exit;
    End;

               pConfigMux := NIL;
               //   
               Result:=FMux.QueryInterface(IID_IConfigAviMux, pConfigMux);
               if FAILED( Result ) then
                begin
                //         
               //         
                  pConfigMux.SetMasterStream(1);
                  pConfigMux := NIL;
                end;

 end;
  //  ImediaControl
 FGraphBuilder.QueryInterface(IID_IMediaControl, FMediaControl);

 //  IVideoWindow
 FGraphBuilder.QueryInterface(IID_IVideoWindow, FVideoWindow);

 //    Panel1
 FVideoWindow.put_Owner(Panel1.Handle);
 FVideoWindow.put_WindowStyle(WS_CHILD or WS_CLIPSIBLINGS);
 FVideoWindow.put_MessageDrain(Panel1.Handle);
 FVideoWindow.SetWindowPosition(0, 0, Panel1.ClientRect.Right,Panel1.ClientRect.Bottom);
 //  
 FMediaControl.Run;
end;
//   ValueListEditor1
procedure TForm1.Button1Click(Sender: TObject);
var Url1, Name1: string;
begin
 Url1:= inputbox('  ?',': mms://live.rfn.ru/vesti_24','');
 if Url1<>'' then begin
      Name1:=InputBox('  ?', ':  24','');
      if Name1<>'' then  ValueListEditor1.InsertRow(Name1,Url1,true);
 end;
end;

//   ValueListEditor1
procedure TForm1.Button2Click(Sender: TObject);
begin
if ValueListEditor1.RowCount<=2 then exit;
ValueListEditor1.deleterow(ValueListEditor1.Row);
end;


//   COM
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  FAudioRender           := nil;
  FVideoRender           := nil;
  FTee_Audio             := nil;
  FTee_Video             := nil;
  FASFReader             := nil;
  FSink                  := NIL;
  FMux                   := NIL;
  FMediaControl          := nil;
  FVideoWindow           := nil;
  FCaptureGraphBuilder   := NIL;
  FGraphBuilder          := Nil;

  CoUninitialize;
  //  
  SaveIniFiles;
  IniFile.Free;
end;

// COM
procedure TForm1.FormCreate(Sender: TObject);
begin
  CoInitialize(nil);
  //  
  LoadIniFiles;
end;

//         
procedure TForm1.FormShow(Sender: TObject);
begin
  if ValueListEditor1.RowCount<>0 then
      Begin
        url:=ValueListEditor1.Cells[1,1];
        Name_ch:=ValueListEditor1.Cells[0,1];
        form1.Caption:=Name_ch;
      End;
end;

//   ValueListEditor1
procedure TForm1.ValueListEditor1Click(Sender: TObject);
begin
 url:=ValueListEditor1.Cells[1,ValueListEditor1.Row];
   Name_ch:=ValueListEditor1.Cells[0,ValueListEditor1.Row];
   form1.Caption:=Name_ch;
end;

procedure TForm1.ValueListEditor1DblClick(Sender: TObject);
begin
   Panel1.Caption:=' ,   ';
   Application.ProcessMessages;
   url:=ValueListEditor1.Cells[1,ValueListEditor1.Row];
   Name_ch:=ValueListEditor1.Cells[0,ValueListEditor1.Row];
   form1.Caption:=Name_ch;
   //   
   //   
If RecMode then
     begin
       SB1.Down:=False;
       SB1.Caption:=' ';
       //  
       RecMode:=False;
       //   
       if Assigned(FMediaControl) then FMediaControl.Stop;
       //    
       if FAILED(CreateGraph) then
        Begin
          ShowMessage('!      ');
          //  
          SB1.Down:=False;
          SB1.Caption:=' ';
          Exit;
        End;
     end else
         if FAILED(CreateGraph) then
              Begin
                ShowMessage('!      ');
                //  
                SB1.Down:=False;
                SB1.Caption:=' ';
                Exit;
              End;
end;

procedure TForm1.LoadIniFiles;
var i: integer;
    Url1, Name1: string;
begin
// inifile    Config.ini
IniFile:=TIniFile.Create(ExtractFilePath(Application.ExeName)+'config.ini');
//   inifile
// 

for i:= 1 to IniFile.ReadInteger('RowCount','Count',0) - 1 do
  begin
  Name1:=IniFile.ReadString('Channel','Name'+inttostr(i),'');
  Url1:=IniFile.ReadString('Channel','Url'+inttostr(i),'');
  ValueListEditor1.InsertRow(Name1,Url1,true);
  end;
end;


//        
procedure TForm1.Panel1Resize(Sender: TObject);
begin
if Assigned(FVideoWindow)  then
FVideoWindow.SetWindowPosition(0,0,Panel1.ClientRect.Right,Panel1.ClientRect.Bottom);
end;

procedure TForm1.SaveIniFiles;
var i: integer;
begin
//   inifile
// 
IniFile.WriteInteger('RowCount','Count',ValueListEditor1.RowCount);
//  PlayList
IniFile.EraseSection('Channel');
//    
for i:=1 to ValueListEditor1.RowCount - 1 do
  begin
    IniFile.WriteString('Channel','Name'+inttostr(i),ValueListEditor1.Cells[0,i]);
    IniFile.WriteString('Channel','Url'+inttostr(i),ValueListEditor1.Cells[1,i]);

  end;

end;

// 
procedure TForm1.SB1Click(Sender: TObject);
begin
Panel1.Caption:=' ,   ';
Application.ProcessMessages;
//   url    
url:=ValueListEditor1.Cells[1,ValueListEditor1.Row];
Name_ch:=ValueListEditor1.Cells[0,ValueListEditor1.Row];
form1.Caption:=Name_ch;
//   
If RecMode then
     begin
       SB1.Down:=False;
       SB1.Caption:=' ';
       //  
       RecMode:=False;
       //   
       if Assigned(FMediaControl) then FMediaControl.Stop;
       //    
       if FAILED(CreateGraph) then
        Begin
          ShowMessage('!      ');
          //  
          SB1.Down:=False;
          SB1.Caption:=' ';
          Exit;
        End;
     end else begin
                 //    
                 RecMode:=True;
                 //   
                 if Assigned(FMediaControl) then FMediaControl.Stop;
                 if FAILED(CreateGraph) then
                   Begin
                      ShowMessage('!      ');
                      //  
                      RecMode:=False;
                      SB1.Down:=False;
                      SB1.Caption:=' ';
                      Exit;
                  End;
                 SB1.Down:=True;
                 SB1.Caption:=' ';
               end;
end;

end.
